// TsRename.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <commctrl.h>
#include "TsRename.h"
#include <shellapi.h>
#include "TsData.h"

#pragma	comment(lib,"comctl32.lib")

#define MAX_LOADSTRING 100

typedef struct tagProgList {
	string	stName;
	string	stCont;
	string	stDetails;
	string	stChName;
	string	stDate;
	string	stSTime;
	string	stDate28;
	string	stSTime28;
	string	stYDate;
	string	stYDate28;
	string	stY2Date;
	string	stY2Date28;
	string	stS2Time;
	string	stS2Time28;
	string	stYDateSTime;
	string	stYDateSTime28;
	string	stY2_Date;
	string	stY2_Date28;
	WORD	serviceId;
	WORD	eventId;
	DWORD	vCount;
	time_t	stime;
	time_t	etime;

	tagProgList() {
		memset(this,0,sizeof(PROG_DATA));
	}
} PROG_DATA;

typedef struct tagFileList {
	string	stFileName;
	string	stFilePath;
	string	stNewName;
	string	stNewFilePath;
	BOOL	bFileNameError;
	int		nSelNo;
	vector<PROG_DATA>	progList;
	tagFileList() {
		memset(this,0,sizeof(FILE_DATA));
	}
} FILE_DATA;

typedef struct tagChNameList {
	string	szChName;
	string	szSubName;
} CH_NAME;

// O[oϐ :
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
TCHAR m_szIniPath[256];
vector<FILE_DATA> m_FileList;
CTsData* m_pTs = NULL;
const char*		m_FileReadDlg_FileName = NULL;
BOOL m_bTsreadCancel = FALSE;
BOOL b_bFileReadFrst = TRUE;
int	m_nSelectItemNo = 0;
POINT m_nSelectItemPos;
string m_stEdtName;
string m_stCont;
BOOL m_bFileDate = FALSE;
BOOL m_bNotFileRename = FALSE;

// ̃R[h W[Ɋ܂܂֐̐錾]܂ :
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK TsRenameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK FileReadDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
LRESULT CALLBACK NameEditDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp);
BOOL tsreadCallBack(long readbyte,long totalbyte,HWND data);

string& replace(string& str, const string sb, const string sa)
{
	string::size_type n, nb = 0;

	for(nb = 0;nb < str.size();nb++) {
		if(strncmp(((char*)(str.c_str()))+nb,sb.c_str(),sb.size()) == 0) {
			str.replace(nb,sb.size(),sa);
			nb += (sa.size()-1);
		}
		else if(_ismbblead(str[nb]))
			nb++;
	}
	//while ((n = str.find(sb,nb)) != string::npos)
	//{
	//	str.replace(n,sb.size(),sa);
	//	nb = n + sa.size();
	//}
	
	return str;
}

LRESULT CALLBACK NameEditDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			SetWindowPos(hWnd,NULL,m_nSelectItemPos.x-14,m_nSelectItemPos.y-16-GetSystemMetrics(SM_CYCAPTION),0,0,SWP_NOSIZE|SWP_NOZORDER);
			SetDlgItemText(hWnd,IDC_EDT_NAME,(char*)m_stEdtName.c_str());
			SetFocus(GetDlgItem(hWnd,IDC_EDT_NAME));
			SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_SETSEL,65535,65535);

			replace(m_stCont,"\r","");
			replace(m_stCont,"\n","");
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == 0x00) {
			switch ( LOWORD(wp) )
			{
			case IDC_PST_CONT:
				{
					WPARAM start;
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_GETSEL,(WPARAM)&start,0);
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_REPLACESEL, 0, (LPARAM)m_stCont.c_str());
					SendMessage(GetDlgItem(hWnd,IDC_EDT_NAME),EM_SETSEL,start,start);
					SetFocus(GetDlgItem(hWnd,IDC_EDT_NAME));
				}
				break;
			case IDOK:
				{
					char sztmp[256];
					GetDlgItemText(hWnd,IDC_EDT_NAME,sztmp,256);
					m_stEdtName = sztmp;
					::EndDialog(hWnd,IDOK);
				}
				break;
			case IDCANCEL:
				::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
		break;
	}
    return 0;
}

BOOL tsreadCallBack(long readbyte,long totalbyte,HWND data)
{
	static time_t lasttime = -1;
	HWND hWnd = data;
	HWND hCount = GetDlgItem(hWnd,IDC_READ_COUNT);
	HWND hProg = GetDlgItem(hWnd,IDC_READ_PROG);
	time_t nowtime = time(NULL);
	char szCount[1024];
	if(nowtime != lasttime) {
		char szRead[20],szTotal[20],szBuf[20],szScr[1024],szOut[2048];
		int len,spos;
		sprintf(szBuf,"%ld",(long)(readbyte/1000));			// 100000
		if(strlen(szBuf) >= 4) {
			for(len = strlen(szBuf)-3;len > 0;len-=3)
				spos = len;
			szRead[0] = 0x00;
			for(len = 0;len < strlen(szBuf);) {
				strncat(szRead,&szBuf[len],spos);
				len += spos;
				spos = 3;
				if(len < strlen(szBuf))
					strcat(szRead,",");
			}
		}
		else
			strcpy(szRead,szBuf);
		sprintf(szBuf,"%ld",(long)(totalbyte/1000));
		if(strlen(szBuf) >= 4) {
			for(len = strlen(szBuf)-3;len > 0;len-=3)
				spos = len;
			szTotal[0] = 0x00;
			for(len = 0;len < strlen(szBuf);) {
				strncat(szTotal,&szBuf[len],spos);
				len += spos;
				spos = 3;
				if(len < strlen(szBuf))
					strcat(szTotal,",");
			}
		}
		else
			strcpy(szTotal,szBuf);
		wsprintf(szCount,"%sMB/%sMB",szRead,szTotal);
		SetWindowText(hCount,szCount);
		lasttime = nowtime;
		if(totalbyte > 0) {
			SendMessage(hProg, PBM_SETPOS,
				(WPARAM)(readbyte*100)/totalbyte,(LPARAM)0);
		}
	}
	if(readbyte == totalbyte) {
		SendMessage(hProg, PBM_SETPOS,
			(WPARAM)100,(LPARAM)0);
		if(m_bTsreadCancel)
			::EndDialog(hWnd,IDCANCEL);
		else
			::EndDialog(hWnd,IDOK);
	}
	MSG msg;
	for(int i = 0;i < 1000;i++) {
		if(PeekMessage(&msg, hWnd, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
			break;
	}
	if(m_bTsreadCancel)
		return FALSE;
	return TRUE;
}

LRESULT CALLBACK FileReadDlgProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
    switch ( msg )
    {
	case WM_INITDIALOG:
		{
			HWND hDesk;
			RECT DeskRect, CRect;
			INT S_PosX, S_PosY;

			hDesk = GetDesktopWindow();
			GetWindowRect(hDesk, &DeskRect);
			GetWindowRect(hWnd, &CRect);
			S_PosX = (INT)(DeskRect.right - (CRect.right - CRect.left)) / 2;
			S_PosY = (INT)(DeskRect.bottom - (CRect.bottom - CRect.top)) / 2;

			SetWindowPos(hWnd, NULL, S_PosX, S_PosY, 0, 0, SWP_NOSIZE | SWP_NOZORDER);

			char szFileName[256],drv[10],path[256],name[256],ext[256];
			_splitpath(m_FileReadDlg_FileName,drv,path,name,ext);
			_makepath(szFileName,NULL,NULL,name,ext);
			SetDlgItemText(hWnd,IDC_FILE_NAME,szFileName);
			SetDlgItemText(hWnd,IDC_READ_COUNT,"");
			HWND hProg = GetDlgItem(hWnd,IDC_READ_PROG);
			SendMessage(hProg, PBM_SETRANGE,
				(WPARAM)0,
				MAKELPARAM(0, 100));
			SendMessage(hProg, PBM_SETPOS,
				(WPARAM)0,(LPARAM)0);
			SetTimer(hWnd,2000,500,NULL);
		}
		break;
	case WM_TIMER:
		if(wp == 2000) {
			KillTimer(hWnd,2000);
			m_bTsreadCancel = FALSE;
			m_pTs->tsread(m_FileReadDlg_FileName,tsreadCallBack,hWnd);
		}
    case WM_COMMAND:
        switch ( LOWORD(wp) )
        {
		case IDCANCEL:
			if(MessageBox(hWnd,"t@C̓ǂݍ݂𒆒f܂H","f",MB_YESNO| MB_ICONQUESTION) == IDYES)
				m_bTsreadCancel = TRUE;
            break;
        }
        break;
    }
    return 0;
}

void SetFileList(HWND hWnd);
void SetItemText(HWND hWnd,int itemNo,BOOL bIns = TRUE);

void SetItemText(HWND hWnd,int itemNo,BOOL bIns)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	vector<int> typeList;
	vector<string> spList;
	vector<FILE_DATA>::iterator fit = m_FileList.begin() + itemNo;

	for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
		HWND hCmbList = GetDlgItem(hWnd,id);
		int type = ComboBox_GetCurSel(hCmbList);
		typeList.push_back(type);
	}
	for(int id = IDC_TSR_SP1;id <= IDC_TSR_SP5;id++) {
		char sp[256];
		GetDlgItemText(hWnd,id,sp,256);
		string stSp = sp;
		spList.push_back(stSp);
	}

	m_bNotFileRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME) , BM_GETCHECK , 0 , 0));

	char szDateTime[100];
	char szNewName[512],sztmp[256];
	LV_ITEM item;
	item.mask = LVIF_TEXT|LVIF_PARAM;
	item.pszText = (char*)fit->stFileName.c_str();
	item.iItem = itemNo;
	item.iSubItem = 0;
	item.lParam = itemNo;
	int insitem;
	if(bIns)
		insitem = ListView_InsertItem(hList,&item);
	else {
		insitem  = itemNo;
		ListView_SetItem(hList,&item);
	}
	int nOverLen = 0;
	fit->bFileNameError = FALSE;
	
	char drv[10],path[256],name[256],ext[256],fullPathName[1024];
	_splitpath((char*)fit->stFilePath.c_str(),drv,path,name,ext);
	szNewName[0] = 0x00;
	vector<int>::iterator tit = typeList.begin();
	vector<string>::iterator sit = spList.begin();
	if(m_bNotFileRename) {
		_makepath(szNewName,NULL,NULL,name,ext);
	}
	else {
		if(fit->progList[fit->nSelNo].stime != 0) {
			while(tit != typeList.end() && sit != spList.end()) {
				//if(szNewName[0] != 0x00)
				//	strcat(szNewName," ");
				strcat(szNewName,(char*)(*sit).c_str());
				switch(*tit) {
					case 1:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stName.c_str());
						break;
					case 2:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stChName.c_str());
						break;
					case 3:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stDate.c_str());
						break;
					case 4:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stSTime.c_str());
						break;
					case 5:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stDate28.c_str());
						break;
					case 6:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stSTime28.c_str());
						break;
					case 7:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDate.c_str());
						break;
					case 8:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDate28.c_str());
						break;
					case 9:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2Date.c_str());
						break;
					case 10:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2Date28.c_str());
						break;
					case 11:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stS2Time.c_str());
						break;
					case 12:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stS2Time28.c_str());
						break;
					case 13:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDateSTime.c_str());
						break;
					case 14:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stYDateSTime28.c_str());
						break;
					case 15:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2_Date.c_str());
						break;
					case 16:
						strcat(szNewName,(char*)fit->progList[fit->nSelNo].stY2_Date28.c_str());
						break;
				}
				tit++;
				sit++;
			}
			if(sit != spList.end())
				strcat(szNewName,(char*)(*sit).c_str());
			if(szNewName[0] != 0x00) {
				if(ext[0] == 0x00)
					strcat(szNewName,".ts");
				else
					strcat(szNewName,ext);
			}
		}

		string sttmp = szNewName;
		replace(sttmp,":","F");
		replace(sttmp,"<","");
		replace(sttmp,">","");
		replace(sttmp,"\\","");
		replace(sttmp,"/","^");
		replace(sttmp,"*","");
		replace(sttmp,"?","H");
		replace(sttmp,"|","b");
		strcpy(szNewName,(char*)sttmp.c_str());
	}
	_splitpath(szNewName,NULL,NULL,name,ext);
	if(strlen(drv)+strlen(path)+strlen(name)+strlen(ext) > 256)
		fit->bFileNameError = TRUE;

	//char *szNotChar = ":<>\\/*?|";

	//for(int i = 0;i < strlen(szNotChar);i++) {
	//	for(int is = 0;is < strlen(name);is++) {
	//		if(_ismbblead(name[is])) {
	//			is++;
	//			continue;
	//		}
	//		if(name[is] == szNotChar[i])
	//			name[is] = '_';
	//	}
	//}

	_makepath(fullPathName,drv,path,name,ext);
	fit->stNewFilePath = fullPathName;

	_makepath(szNewName,NULL,NULL,name,ext);
	fit->stNewName = szNewName;
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->stNewName.c_str();
	item.iItem = insitem;
	item.iSubItem = 1;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stName.c_str();
	item.iItem = insitem;
	item.iSubItem = 2;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stChName.c_str();
	item.iItem = insitem;
	item.iSubItem = 3;
	ListView_SetItem(hList, &item);
	wsprintf(szDateTime,"%s %s",(char*)fit->progList[fit->nSelNo].stDate.c_str(),(char*)fit->progList[fit->nSelNo].stSTime.c_str());
	item.mask = LVIF_TEXT;
	item.pszText = szDateTime;
	item.iItem = insitem;
	item.iSubItem = 4;
	ListView_SetItem(hList, &item);
	item.mask = LVIF_TEXT;
	item.pszText = (char*)fit->progList[fit->nSelNo].stCont.c_str();
	item.iItem = insitem;
	item.iSubItem = 5;
	ListView_SetItem(hList, &item);
}

void SetFileList(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
	ListView_DeleteAllItems(hList);

	int itemNo = 0;
	vector<FILE_DATA>::iterator fit = m_FileList.begin();
	while(fit != m_FileList.end()) {
		SetItemText(hWnd,itemNo,TRUE);
		itemNo++;
		fit++;
	}
	ListView_EnsureVisible(hList,itemNo-1,FALSE);
}

LRESULT CALLBACK TsRenameDlgProc(HWND hWnd,UINT meg,WPARAM wp,LPARAM lp)
{
    switch ( meg )
    {
	case WM_INITDIALOG:
		{
			HMENU hSysMenu = GetSystemMenu(hWnd,FALSE);
			InsertMenu(hSysMenu,SC_CLOSE,MF_BYCOMMAND|MF_STRING,IDM_ABOUT,"o[W(&A)...");

			m_FileList.clear();

			char szItem[100],szData[256];

			wsprintf(szItem,"FilenameSetSp%d",IDC_TSR_SP1);
			GetPrivateProfileString("TsRenameDlg",szItem,"",szData,256,m_szIniPath);
			//szData[strlen(szData)-1] = 0x00;
			SetDlgItemText(hWnd,IDC_TSR_SP1,szData);
			for(int id = IDC_TSR_SP2;id <= IDC_TSR_SP4;id++) {
				wsprintf(szItem,"FilenameSetSp%d",id);
				GetPrivateProfileString("TsRenameDlg",szItem," ",szData,256,m_szIniPath);
				//szData[strlen(szData)-1] = 0x00;
				SetDlgItemText(hWnd,id,szData);
			}
			wsprintf(szItem,"FilenameSetSp%d",IDC_TSR_SP5);
			GetPrivateProfileString("TsRenameDlg",szItem,"",szData,256,m_szIniPath);
			//szData[strlen(szData)-1] = 0x00;
			SetDlgItemText(hWnd,IDC_TSR_SP5,szData);

			for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
				HWND hCmbList = GetDlgItem(hWnd,id);
				ComboBox_AddString(hCmbList,"gp");
				ComboBox_AddString(hCmbList,"ԑg");
				ComboBox_AddString(hCmbList,"CH");
				ComboBox_AddString(hCmbList,"mmdd(w)");
				ComboBox_AddString(hCmbList,"hhmm");
				ComboBox_AddString(hCmbList,"mmdd(w)(28)");
				ComboBox_AddString(hCmbList,"hhmm(28)");
				ComboBox_AddString(hCmbList,"yyyyNmmdd(w)");
				ComboBox_AddString(hCmbList,"yyyyNmmdd(w)(28)");
				ComboBox_AddString(hCmbList,"yyyy^mm^dd");
				ComboBox_AddString(hCmbList,"yyyy^mm^dd(28)");
				ComboBox_AddString(hCmbList,"hhFmm");
				ComboBox_AddString(hCmbList,"hhFmm(28)");
				ComboBox_AddString(hCmbList,"yyyymmddhhmm");
				ComboBox_AddString(hCmbList,"yyyymmddhhmm(28)");
				ComboBox_AddString(hCmbList,"yyyy-mm-dd");
				ComboBox_AddString(hCmbList,"yyyy-mm-dd(28)");
				wsprintf(szItem,"FilenameSet%d",id);
				int def = GetPrivateProfileInt("TsRenameDlg",szItem,0,m_szIniPath);
				ComboBox_SetCurSel(hCmbList,def);
			}
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);

			DWORD dwStyle;
			dwStyle = ListView_GetExtendedListViewStyle(hList);
			dwStyle |= LVS_EX_FULLROWSELECT;/*| LVS_EX_GRIDLINES*/;
			ListView_SetExtendedListViewStyle(hList, dwStyle);

			LV_COLUMN lvcol;
			lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
			lvcol.fmt = LVCFMT_LEFT;
			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","OLDW",100,m_szIniPath);
			lvcol.pszText = "t@C";
			lvcol.iSubItem = 0;
			ListView_InsertColumn(hList, 0, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","NEWW",100,m_szIniPath);
			lvcol.pszText = "Vt@C";
			lvcol.iSubItem = 1;
			ListView_InsertColumn(hList, 1, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","NAMEW",100,m_szIniPath);
			lvcol.pszText = "ԑg";
			lvcol.iSubItem = 2;
			ListView_InsertColumn(hList, 2, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","CHW",100,m_szIniPath);
			lvcol.pszText = "CH";
			lvcol.iSubItem = 3;
			ListView_InsertColumn(hList, 3, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","DATEW",100,m_szIniPath);
			lvcol.pszText = "";
			lvcol.iSubItem = 4;
			ListView_InsertColumn(hList, 4, &lvcol);

			lvcol.cx = GetPrivateProfileInt("TsRenameDlg","CONTW",100,m_szIniPath);
			lvcol.pszText = "e";
			lvcol.iSubItem = 5;
			ListView_InsertColumn(hList, 5, &lvcol);
			if(GetPrivateProfileString("TsRenameDlg","WindowX","100",szData,100,m_szIniPath) > 0) {
				int x = atoi(szData);
				if(GetPrivateProfileString("TsRenameDlg","WindowY","100",szData,100,m_szIniPath) > 0) {
					int y = atoi(szData);
					if(GetPrivateProfileString("TsRenameDlg","WindowCX","930",szData,100,m_szIniPath) > 0) {
						int cx = atoi(szData);
						if(GetPrivateProfileString("TsRenameDlg","WindowCY","500",szData,100,m_szIniPath) > 0) {
							int cy = atoi(szData);
							SetWindowPos(hWnd,NULL,x,y,cx,cy,SWP_NOZORDER);
						}
					}
				}
			}

			m_bNotFileRename = GetPrivateProfileInt("TsRenameDlg","NotRename",m_bNotFileRename,m_szIniPath);
			m_bFileDate = GetPrivateProfileInt("TsRenameDlg","FileDate",m_bFileDate,m_szIniPath);

			SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME), BM_SETCHECK, m_bNotFileRename ? BST_CHECKED:BST_UNCHECKED, 0L);
			SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE), BM_SETCHECK, m_bFileDate ? BST_CHECKED:BST_UNCHECKED, 0L);

			DragAcceptFiles(hWnd,TRUE);

			PostMessage(hWnd,WM_SIZE,0,0);
		}
		break;
	case WM_GETMINMAXINFO:
		{
			RECT btnrct,listrct;
			POINT pos;
			GetWindowRect(GetDlgItem(hWnd,IDCANCEL),&btnrct);
			GetWindowRect(GetDlgItem(hWnd,IDC_TSR_LIST),&listrct);
			pos.x = btnrct.right+100;
			pos.y = listrct.top+64;
			ScreenToClient(hWnd,&pos);

			LPMINMAXINFO lpmmi;

			lpmmi = (LPMINMAXINFO)lp;
			lpmmi->ptMinTrackSize.x = pos.x;
			lpmmi->ptMinTrackSize.y = pos.y;
			SetWindowLong(hWnd,DWL_MSGRESULT,0);
			return TRUE;
		}
		break;
	case WM_SIZE:
		{
			RECT dlgrct,listrct;
			POINT pos;
			GetClientRect(hWnd,&dlgrct);
			GetWindowRect(GetDlgItem(hWnd,IDC_TSR_LIST),&listrct);
			pos.x = listrct.left;
			pos.y = listrct.top;
			ScreenToClient(hWnd,&pos);
			int dlgw = dlgrct.right-dlgrct.left;
			int dlgh = dlgrct.bottom-dlgrct.top;
			SetWindowPos(GetDlgItem(hWnd,IDC_TSR_LIST),NULL,0,pos.y,dlgw,dlgh-pos.y,SWP_NOZORDER);
		}
		break;
	case WM_SYSCOMMAND:
		{
			switch (LOWORD(wp)) {
			case IDM_ABOUT:
				DialogBox(hInst,MAKEINTRESOURCE(IDD_ABOUTBOX),hWnd,(DLGPROC)About);
				break;
			}
		}
		break;
    case WM_COMMAND:
		if(LOWORD(wp) >= IDC_TSR_SP1 && LOWORD(wp) <= IDC_TSR_SP5)
		{
			if(HIWORD(wp) == EN_CHANGE)
			{
				SetFileList(hWnd);
			}
		}
		if(LOWORD(wp) >= IDC_TSR_CMB && LOWORD(wp) <= IDC_TSR_CMB4)
		{
			if(HIWORD(wp) == CBN_SELCHANGE)
			{
				SetFileList(hWnd);
			}
		}
		else if(LOWORD(wp) == IDM_ALLSEL) {
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
				ListView_SetItemState(hList,itemNo,LVIS_SELECTED,LVIS_SELECTED);
			}
			SetFocus(hList);
		}
		else if(HIWORD(wp) == 0x00) {
			if(LOWORD(wp) >= IDM_TSR_NAME_SELECT && LOWORD(wp) <= IDM_TSR_NAME_SELECT+100) {
				if(m_nSelectItemNo >= 0 && m_nSelectItemNo < m_FileList.size()) {
					m_FileList[m_nSelectItemNo].nSelNo = (LOWORD(wp) - IDM_TSR_NAME_SELECT);
					//SetFileList(hWnd);
					SetItemText(hWnd,m_nSelectItemNo,FALSE);
				}
				break;
			}
			switch ( LOWORD(wp) )
			{
			case IDC_TSR_ALLSEL:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
						ListView_SetItemState(hList,itemNo,LVIS_SELECTED,LVIS_SELECTED);
					}
					SetFocus(hList);
				}
				break;
			case IDC_TSR_NOTRENAME:
				SetFileList(hWnd);
				break;
			case IDM_TSR_NAME_EDIT:
				m_stEdtName = m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stName;
				m_stCont = m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stCont;
				if(IDOK == DialogBox(hInst,MAKEINTRESOURCE(IDD_TSR_EDITNAME),hWnd,(DLGPROC)NameEditDlgProc)) {
					m_FileList[m_nSelectItemNo].progList[m_FileList[m_nSelectItemNo].nSelNo].stName = m_stEdtName;
					SetItemText(hWnd,m_nSelectItemNo,FALSE);
				}
				break;
			case IDC_TSR_DEL:
				{
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,-1,LVNI_ALL | LVNI_SELECTED)) != -1) {
						vector<FILE_DATA>::iterator fit = m_FileList.begin() + selitem;
						m_FileList.erase(fit);
						ListView_DeleteItem(hList,selitem);
						for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
							LV_ITEM item;
							item.mask = LVIF_PARAM;
							item.iItem = itemNo;
							item.iSubItem = 0;
							ListView_GetItem(hList,&item);
							if(item.lParam > selitem) {
								item.lParam--;
								ListView_SetItem(hList,&item);
							}
						}
					}
					for(int itemNo = 0;itemNo < ListView_GetItemCount(hList);itemNo++) {
						LV_ITEM item;
						item.mask = LVIF_PARAM;
						item.iItem = itemNo;
						item.iSubItem = 0;
						ListView_GetItem(hList,&item);
						char szMsg[256];
						wsprintf(szMsg,"%d,%d,%s\r\n",itemNo,item.lParam,(char*)m_FileList[item.lParam].stFilePath.c_str());
						OutputDebugString(szMsg);
					}
					//SetFileList(hWnd);
				}
				break;
			case IDOK:
				{
					m_bFileDate = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE) , BM_GETCHECK , 0 , 0));
					HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
					int selitem = -1;
					while((selitem = ListView_GetNextItem(hList,selitem,LVNI_ALL | LVNI_SELECTED)) != -1) {
						vector<FILE_DATA>::iterator fit = m_FileList.begin() + selitem;
						if(!fit->bFileNameError && fit->stFilePath != fit->stNewFilePath && !fit->stFilePath.empty() && !fit->stNewFilePath.empty() && !fit->stNewName.empty()) {
							char drv[10],path[256],name[256],ext[256],szName[1024],name2[256],szEx[10];
							_splitpath((char*)fit->stNewFilePath.c_str(),drv,path,name,ext);
							for(int i = 0;i < 100;i++) {
								strcpy(name2,name);
								if(i == 0)
									szEx[0] = 0x00;
								else
									sprintf(szEx,"(%d)",i);
								strcat(name2,szEx);
								_makepath(szName,drv,path,name2,ext);
								if(_access(szName,0) != 0) {
									fit->stNewFilePath = szName;
									break;
								}
							}
							if(MoveFile((char*)fit->stFilePath.c_str(),(char*)fit->stNewFilePath.c_str())) {
								fit->stFilePath = fit->stNewFilePath;
								_splitpath((char*)fit->stNewFilePath.c_str(),drv,path,name,ext);
								_makepath(szName,NULL,NULL,name,ext);
								fit->stFileName = szName;
							}
						}
						if(m_bFileDate) {
							SYSTEMTIME systime;
							FILETIME updatedate,forSetFileTime;
							HANDLE hFile = CreateFile((char*)fit->stFilePath.c_str(),
								  GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
							if(hFile != INVALID_HANDLE_VALUE) {
								memset(&systime, 0, sizeof(systime));
								memset(&updatedate, 0, sizeof(updatedate));
								memset(&forSetFileTime, 0, sizeof(forSetFileTime));
								struct tm* tmt = localtime(&(fit->progList[fit->nSelNo].stime));
								systime.wYear = tmt->tm_year + 1900;
								systime.wMonth = tmt->tm_mon + 1;
								systime.wDay = tmt->tm_mday;
								systime.wDayOfWeek = tmt->tm_wday;
								systime.wHour = tmt->tm_hour;
								systime.wMinute = tmt->tm_min;
								systime.wSecond = tmt->tm_sec;
								systime.wMilliseconds = 0;
								// t@C^C`ɕϊ
								SystemTimeToFileTime(&systime, &updatedate);
								// SetFileTime()pɕϊ
								LocalFileTimeToFileTime(&updatedate, &forSetFileTime);
								SetFileTime(hFile,&forSetFileTime,NULL,&forSetFileTime);
								CloseHandle(hFile);
							}
						}
					}
					SetFileList(hWnd);
				}
				break;
			case IDCANCEL:
				DestroyWindow(hWnd);
				//::EndDialog(hWnd,IDCANCEL);
				break;
			}
		}
        break;
	case WM_DROPFILES:
		{
			int NameLen = 0;
			char szPathName[MAX_PATH +1] = "";
			HDROP hDrop = (HDROP) wp;

			int Count = DragQueryFile(
			hDrop,0xFFFFFFFF,szPathName,256);

			char drv[10],path[256],name[256],ext[256],szName[256];
			for(int i=0; i < Count; i++) {
				NameLen = DragQueryFile(hDrop,
				i,szPathName,MAX_PATH);
				szPathName[NameLen] = '\0';
				vector<FILE_DATA>::iterator fit = m_FileList.begin();
				BOOL bExist = FALSE;
				while(fit != m_FileList.end()) {
					if(fit->stFilePath.compare(szPathName) == 0) {
						bExist = TRUE;
						break;
					}
					fit++;
				}
				if(bExist)
					continue;
				m_pTs = new CTsData();
				m_FileReadDlg_FileName = szPathName;
				if(IDCANCEL == DialogBox(hInst,MAKEINTRESOURCE(IDD_FILE_READ),
					hWnd,(DLGPROC)FileReadDlgProc)) {
						break;
				}
				//m_pTs->tsread(szPathName);
				int networkId = 0;
				map<DWORD,CH_NAME> mapSvcName;
				mapSvcName.clear();
				int lastsvcid = -1;
				for(int svc = 0;svc < SVC_MAX;svc++) {
					if(!m_pTs->SvcData[svc])
						break;
					// }``l͕\Ȃ
					BOOL bMulti = FALSE;
					if(lastsvcid+1 == m_pTs->SvcData[svc]->Service_id) {
						lastsvcid = m_pTs->SvcData[svc]->Service_id;
						bMulti = TRUE; 
						//continue;
					}
					networkId = GetNetId(m_pTs->SvcData[svc]->chNo);
					if(GetNetId(m_pTs->SvcData[svc]->chNo) > 4)
						bMulti = FALSE;
					lastsvcid = m_pTs->SvcData[svc]->Service_id;
					if(m_pTs->SvcData[svc]->nTsNameLen > 0 && !bMulti) {
						char *poutstr = new char[m_pTs->SvcData[svc]->nTsNameLen*2+20];
						Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szTsName,m_pTs->SvcData[svc]->nTsNameLen,poutstr,m_pTs->SvcData[svc]->nTsNameLen*2+20);
						if(strlen(poutstr) >= 100)
							poutstr[99] = 0x00;
						strcpy(szName,poutstr);
						delete[] poutstr;
					}
					else {
						if(m_pTs->SvcData[svc]->nNameLen > 0) {
							char *poutstr = new char[m_pTs->SvcData[svc]->nNameLen*2+20];
							Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szName,m_pTs->SvcData[svc]->nNameLen,poutstr,m_pTs->SvcData[svc]->nNameLen*2+20);
							if(strlen(poutstr) >= 100)
								poutstr[99] = 0x00;
							strcpy(szName,poutstr);
							delete[] poutstr;
						}
						else {
							if(((m_pTs->SvcData[svc]->chNo)&0xfff) > 0)
								wsprintf(szName,"%dch",((m_pTs->SvcData[svc]->chNo)&0xfff));
							else {
								if(GetNetId(m_pTs->SvcData[svc]->chNo) == 4)
									wsprintf(szName,"BS%d",m_pTs->SvcData[svc]->Service_id);
								else if(GetNetId(m_pTs->SvcData[svc]->chNo) == 6 || GetNetId(m_pTs->SvcData[svc]->chNo) == 7)
									wsprintf(szName,"CS%d",m_pTs->SvcData[svc]->Service_id);
								else
									wsprintf(szName,"%d",m_pTs->SvcData[svc]->Service_id);
							}
						}
					}
					string stName = szName;
					mapSvcName[m_pTs->SvcData[svc]->Service_id].szChName = stName;
					if(m_pTs->SvcData[svc]->nNameLen > 0) {
						char *poutstr = new char[m_pTs->SvcData[svc]->nNameLen*2+20];
						Convert_jpn_arib_char((char*)m_pTs->SvcData[svc]->szName,m_pTs->SvcData[svc]->nNameLen,poutstr,m_pTs->SvcData[svc]->nNameLen*2+20);
						if(strlen(poutstr) >= 100)
							poutstr[99] = 0x00;
						strcpy(szName,poutstr);
						delete[] poutstr;
						stName = szName;
					}
					mapSvcName[m_pTs->SvcData[svc]->Service_id].szSubName = stName;
				}
				FILE_DATA filedata;
				filedata.stFilePath = szPathName;
				_splitpath(szPathName,drv,path,name,ext);
				_makepath(szName,NULL,NULL,name,ext);
				filedata.stFileName = szName;
				vector<PAT_TABLE>::iterator tit = m_pTs->PatList.begin();
				while(tit != m_pTs->PatList.end()) {
					MsgOut("Pat Version = %d\r\n",tit->patVersion);
					vector<PAT_DATA>::iterator dit = tit->patTable.begin();
					while(dit != tit->patTable.end()) {
						MsgOut("PID:%03x(%d),VideoPID:%03x(%d)\r\n",dit->pmtPid,dit->Service_id,dit->vPid,dit->vCount);
						BYTE* pSecData = dit->nowEit.GetData();
						if(pSecData) {
							BYTE* ebuf = &pSecData[14];
							int section_length = dit->nowEit.GetDataSize()-3;
							// Epgf[^̊JnAԂ擾
							int looplen = ((ebuf[10]<<8)+ebuf[11])&0x0fff;
							time_t stime;
							time_t etime;
							m_pTs->ConvDate(&ebuf[2],&stime,&etime);
							BYTE* lbuf = &ebuf[12];
							char szname[160],szcont[340];
							int vt = 0,at = 0,genre = -1,genre2 = -1;
							int eventId = (ebuf[0]<<8)+ebuf[1];
							szname[0] = 0x00;
							szcont[0] = 0x00;
							while(lbuf < &ebuf[12+looplen] && lbuf < &pSecData[section_length+3-4]) {
								BYTE* dbuf = lbuf;
								int dlen = lbuf[1];
								lbuf += (dlen+2);
								if(dbuf[0] == 0x4d) {
									int name = 0;
									dbuf += 5;
									while(dbuf < lbuf) {
										int len = dbuf[0];
										dbuf++;
										if(len > 0) {
											char *poutstr = new char[len*2+80];
											Convert_jpn_arib_char((char*)dbuf,len,poutstr,len*2+80);
											if(name == 0) {
												if(strlen(poutstr) >= 160)
													poutstr[99] = 0x00;
												strcpy(szname,poutstr);
											}
											else {
												if(strlen(poutstr) >= 340)
													poutstr[339] = 0x00;
												strcpy(szcont,poutstr);
											}
											delete[] poutstr;
											dbuf+=len;
											name++;
										}
									}
								}
								else if(dbuf[0] == 0x50) {
									vt = dbuf[3];
								}
								else if(dbuf[0] == 0xc4) {
									at = dbuf[3];
								}
								else if(dbuf[0] == 0x54) {
									genre = (dbuf[2]>>4)&0x0f;
									genre2 = (dbuf[2]&0x0f);
								}
							}
							// ԑg
							if(szname[0] != 0x00) {
								PROG_DATA progdata;
								progdata.stime = stime;
								progdata.etime = etime;
								progdata.eventId = eventId;
								progdata.stName = szname;
								progdata.stCont = szcont;
								progdata.serviceId = dit->Service_id;
								progdata.stDetails.clear();
								progdata.vCount = dit->vCount;
								int nhour,nmin;
								struct tm* enTime;
								struct tm* stTime;
								char* szwday[7] = {"","","","","","","y"};
								char sztmp[1024];
								char szDate[50];
								map<DWORD,CH_NAME>::iterator sit = mapSvcName.find(dit->Service_id);
								if(sit != mapSvcName.end()) {
									if(vt>>4 == 0 || vt>>4 == 0x0a)
										strcpy(sztmp,(char*)sit->second.szSubName.c_str());
									else
										strcpy(sztmp,(char*)sit->second.szChName.c_str());
								}
								else {
									if(networkId == 4)
										wsprintf(sztmp,"BS%d",dit->Service_id);
									else if(networkId == 6 || networkId == 7)
										wsprintf(sztmp,"CS%d",dit->Service_id);
									else
										wsprintf(sztmp,"%d",dit->Service_id);
								}
								progdata.stChName = sztmp;
								stTime = localtime( &stime);
								wsprintf(szDate,"%02d%02d(%s)",stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
								progdata.stDate = szDate;
								wsprintf(szDate,"%04dN%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
								progdata.stYDate = szDate;
								wsprintf(szDate,"%04d^%02d^%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
								progdata.stY2Date = szDate;
								wsprintf(szDate,"%04d-%02d-%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
								progdata.stY2_Date = szDate;
								wsprintf(szDate,"%04d%02d%02d%02d%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,stTime->tm_hour,stTime->tm_min);
								progdata.stYDateSTime = szDate;
								wsprintf(szDate,"%02d%02d",stTime->tm_hour,stTime->tm_min);
								progdata.stSTime = szDate;
								wsprintf(szDate,"%02dF%02d",stTime->tm_hour,stTime->tm_min);
								progdata.stS2Time = szDate;
								if(stTime->tm_hour >= 0 && stTime->tm_hour <= 4) {
									wsprintf(szDate,"%02d%02d",stTime->tm_hour+24,stTime->tm_min);
									progdata.stSTime28 = szDate;
									wsprintf(szDate,"%02dF%02d",stTime->tm_hour+24,stTime->tm_min);
									progdata.stS2Time28 = szDate;
									time_t stime28 = stime - (24 * 60 * 60);
									stTime = localtime( &stime28);
									wsprintf(szDate,"%02d%02d(%s)",stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
									progdata.stDate28 = szDate;
									wsprintf(szDate,"%04dN%02d%02d(%s)",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,szwday[stTime->tm_wday]);
									progdata.stYDate28 = szDate;
									wsprintf(szDate,"%04d^%02d^%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
									progdata.stY2Date28 = szDate;
									wsprintf(szDate,"%04d-%02d-%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday);
									progdata.stY2_Date28 = szDate;
									wsprintf(szDate,"%04d%02d%02d%02d%02d",stTime->tm_year+1900,stTime->tm_mon+1,stTime->tm_mday,stTime->tm_hour+24,stTime->tm_min);
									progdata.stYDateSTime28 = szDate;
								}
								else {
									progdata.stDate28 = progdata.stDate;
									progdata.stSTime28 = progdata.stSTime;
									progdata.stYDate28 = progdata.stYDate;
									progdata.stY2Date28 = progdata.stY2Date;
									progdata.stS2Time28 = progdata.stS2Time;
									progdata.stYDateSTime28 = progdata.stYDateSTime;
								}
								BOOL bAdd = TRUE;
								// d`FbN
								vector<PROG_DATA>::iterator pit = filedata.progList.begin();
								while(pit != filedata.progList.end()) {
									if(pit->stName.compare(progdata.stName) == 0 && pit->eventId == progdata.eventId) {
										bAdd = FALSE;
										break;
									}
									pit++;
								}
								if(bAdd) {
									int pos = -1;
									vector<PROG_DATA>::iterator pit = filedata.progList.begin();
									while(pit != filedata.progList.end()) {
										BOOL bIns = FALSE;
										if(pit->vCount < progdata.vCount)
											bIns = TRUE;
										if(bIns) {
											filedata.progList.insert(pit,progdata);
											pos = i;
											break;
										}
										pit++;
									}
									if(pos == -1)
										filedata.progList.push_back(progdata);
								}
							}
						}
						dit++;
					}
					tit++;
				}
				if(filedata.progList.empty()) {
					PROG_DATA progdata;
					progdata.stName = "f[^L܂";
					filedata.progList.push_back(progdata);
				}
				m_FileList.push_back(filedata);
				delete m_pTs;
				SetFileList(hWnd);
				MSG msg;
				for(int i = 0;i < 100;i++) {
					if(PeekMessage(&msg,NULL,0,0,PM_REMOVE)){
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}
			}
			DragFinish(hDrop);//J
		}
		break;
	case WM_NOTIFY:
		{
			LPNMLVCUSTOMDRAW	lplvcd;
			LPNMLISTVIEW		lpnmlv;
			LPNMHDR				lpnmhdr;
			lpnmhdr = (LPNMHDR)lp;
			HWND hList=lpnmhdr->hwndFrom;
			if(hList != GetDlgItem(hWnd,IDC_TSR_LIST))
				break;
			switch(lpnmhdr->code) {
				case NM_CLICK:
					{
						LPNMLISTVIEW lpnmlv = (LPNMLISTVIEW)lp;
						if(lpnmlv->iItem != -1) {
							LV_ITEM item;
							item.mask = LVIF_PARAM;
							item.iItem = lpnmlv->iItem;
							item.iSubItem = 0;
							ListView_GetItem(hList,&item);
							if(lpnmlv->iSubItem == 2 && item.lParam >= 0) {
								if(m_FileList[item.lParam].progList[0].stime > 0) {
									SetForegroundWindow(hWnd);	//EBhEtHAOEhɎĂ܂B
									SetFocus(hWnd);	//ȂƁAj[ȂȂ܂B
									HMENU hSubmenu = CreatePopupMenu();
									MENUITEMINFO mi;
									memset(&mi, 0, sizeof(MENUITEMINFO));
									mi.cbSize = sizeof(MENUITEMINFO);
									mi.fMask = MIIM_TYPE | MIIM_STATE | MIIM_ID;
									mi.fType = MFT_STRING;
									mi.fState = MFS_ENABLED;
									char szData[1024];
									int i;
									for(i = 0;i < m_FileList[item.lParam].progList.size();i++) {
										mi.fState = MFS_ENABLED;
										mi.wID = IDM_TSR_NAME_SELECT + i;
										//if(i == m_FileList[item.lParam].nSelNo)
										//	mi.fState |= MFS_CHECKED;
										wsprintf(szData,"%s [%s]",(char*)m_FileList[item.lParam].progList[i].stName.c_str(),(char*)m_FileList[item.lParam].progList[i].stChName.c_str());
										mi.dwTypeData = szData;
										InsertMenuItem(hSubmenu,i,FALSE,&mi);
									}
									CheckMenuRadioItem( hSubmenu, IDM_TSR_NAME_SELECT, IDM_TSR_NAME_SELECT + (i-1),LOWORD( IDM_TSR_NAME_SELECT + m_FileList[item.lParam].nSelNo ),MF_BYCOMMAND );
									InsertMenu(hSubmenu,i++,MF_SEPARATOR,0,NULL);
									mi.fState = MFS_ENABLED;
									mi.wID = IDM_TSR_NAME_EDIT;
									mi.dwTypeData = "ԑgҏW";
									InsertMenuItem(hSubmenu,i++,FALSE,&mi);
									RECT btnrct;
									ListView_GetSubItemRect(hList,lpnmlv->iItem,lpnmlv->iSubItem,LVIR_LABEL,&btnrct);
									POINT pos;
									pos.x = btnrct.left;
									pos.y = btnrct.bottom;
									ClientToScreen(hList,&pos);
									m_nSelectItemNo = item.lParam;
									m_nSelectItemPos.x = btnrct.left;
									m_nSelectItemPos.y = btnrct.top;
									ClientToScreen(hList,&m_nSelectItemPos);
									//GetCursorPos(&pos);
									TrackPopupMenu(hSubmenu, TPM_LEFTALIGN |TPM_TOPALIGN |TPM_RIGHTBUTTON | TPM_LEFTBUTTON,pos.x,pos.y,0,hWnd,NULL);
									PostMessage(hWnd, WM_NULL ,0,0);	//ȂƁAQxڂ̃j[Ⴂ܂B
								}
							}
							else if(lpnmlv->iSubItem == 5 && item.lParam >= 0) {
								char szData[1024];
								string stCont = m_FileList[item.lParam].progList[m_FileList[item.lParam].nSelNo].stCont;
								if(stCont.empty())
									break;
								SetForegroundWindow(hWnd);	//EBhEtHAOEhɎĂ܂B
								SetFocus(hWnd);	//ȂƁAj[ȂȂ܂B
								HMENU hSubmenu = CreatePopupMenu();
								MENUITEMINFO mi;
								int itemNo = 0;
								memset(&mi, 0, sizeof(MENUITEMINFO));
								mi.cbSize = sizeof(MENUITEMINFO);
								mi.fMask = MIIM_TYPE;
								mi.fType = MFT_STRING;
								const char *str0 = stCont.c_str();
								const char *strlast = stCont.c_str() + strlen(stCont.c_str());
								if(*(strlast-1) == 0x0d)
									strlast--;
								while(str0 < strlast) {
									const char *str = strstr(str0,"\r");
									if(str == NULL) {
										str = strlast;
									}
									if(str-str0 > 66) {
										int is;
										for(is = 0;is < str-str0;is++) {
											if(_ismbblead(*(str0+is)))
												is++;
											if(is >= 60)
												break;
										}
										str = str0 + is - 1;
										strncpy(szData,str0,str-str0);
										szData[str-str0] = 0x00;
										mi.dwTypeData = szData;
										InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
										str0 = str;
									}
									else {
										strncpy(szData,str0,str-str0);
										szData[str-str0] = 0x00;
										mi.dwTypeData = szData;
										InsertMenuItem(hSubmenu,itemNo++,FALSE,&mi);
										str0 = str+1;
									}
								}
								RECT btnrct;
								ListView_GetSubItemRect(hList,lpnmlv->iItem,lpnmlv->iSubItem,LVIR_LABEL,&btnrct);
								POINT pos;
								pos.x = btnrct.left;
								pos.y = btnrct.bottom;
								ClientToScreen(hList,&pos);
								m_nSelectItemNo = item.lParam;
								//GetCursorPos(&pos);
								TrackPopupMenu(hSubmenu, TPM_LEFTALIGN |TPM_TOPALIGN |TPM_RIGHTBUTTON | TPM_LEFTBUTTON,pos.x,pos.y,0,hWnd,NULL);
								PostMessage(hWnd, WM_NULL ,0,0);	//ȂƁAQxڂ̃j[Ⴂ܂B
							}
						}
					}
					break;
				case NM_CUSTOMDRAW :
				// ---- JX^h[ŁAListview̐FݒB
					LPNMLVCUSTOMDRAW lplvcd = (LPNMLVCUSTOMDRAW)lp;
					switch (lplvcd->nmcd.dwDrawStage) {
						case CDDS_PREPAINT:     // `OITEMNGXg
							SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NOTIFYITEMDRAW);
							return TRUE;
						case CDDS_ITEMPREPAINT: // ITEM`OSUBITEMNGXg
							SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NOTIFYSUBITEMDRAW);
							return TRUE;
						case CDDS_ITEMPREPAINT|CDDS_SUBITEM:    // SUBITEM`Cxg
							{
								LV_ITEM item;
								item.mask = LVIF_PARAM;
								item.iItem = lplvcd->nmcd.dwItemSpec;
								item.iSubItem = 0;
								ListView_GetItem(hList,&item);
								if(lplvcd->nmcd.dwItemSpec%2) {
									lplvcd->clrTextBk = RGB(0xef,0xef,0xff);
								}
								else {
									lplvcd->clrTextBk = RGB(0xf4,0xf4,0xff);
								}
								if(m_FileList[item.lParam].progList.size() > 1 && lplvcd->iSubItem == 2)
									lplvcd->clrTextBk = RGB(0xb7,0xff,0xb7);
								if(m_FileList[item.lParam].bFileNameError && lplvcd->iSubItem == 1)
									lplvcd->clrTextBk = RGB(0xff,0,0);
								SetWindowLong(hWnd,DWL_MSGRESULT,(long)CDRF_NEWFONT);
							}
							return TRUE;
					}
					break;
			}
		}
		break;
	case WM_DESTROY:
		{
			char szItem[100];
			char szData[256];
			HWND hList = GetDlgItem(hWnd,IDC_TSR_LIST);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,0));
			WritePrivateProfileString("TsRenameDlg","OLDW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,1));
			WritePrivateProfileString("TsRenameDlg","NEWW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,2));
			WritePrivateProfileString("TsRenameDlg","NAMEW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,3));
			WritePrivateProfileString("TsRenameDlg","CHW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,4));
			WritePrivateProfileString("TsRenameDlg","DATEW",szData,m_szIniPath);
			wsprintf(szData,"%d",ListView_GetColumnWidth(hList,5));
			WritePrivateProfileString("TsRenameDlg","CONTW",szData,m_szIniPath);
			long style = GetWindowLong(hWnd,GWL_STYLE);
			if(!(style & WS_MINIMIZE || style & WS_MAXIMIZE)) {
				RECT dlgrct;
				GetWindowRect(hWnd,&dlgrct);
				wsprintf(szData,"%d",dlgrct.left);
				WritePrivateProfileString("TsRenameDlg","WindowX",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.top);
				WritePrivateProfileString("TsRenameDlg","WindowY",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.right-dlgrct.left);
				WritePrivateProfileString("TsRenameDlg","WindowCX",szData,m_szIniPath);
				wsprintf(szData,"%d",dlgrct.bottom-dlgrct.top);
				WritePrivateProfileString("TsRenameDlg","WindowCY",szData,m_szIniPath);
			}
			for(int id = IDC_TSR_SP1;id <= IDC_TSR_SP5;id++) {
				char sztmp[256];
				GetDlgItemText(hWnd,id,szData,256);
				wsprintf(sztmp,"\"%s\"",szData);
				wsprintf(szItem,"FilenameSetSp%d",id);
				WritePrivateProfileString("TsRenameDlg",szItem,sztmp,m_szIniPath);
			}
			for(int id = IDC_TSR_CMB;id <= IDC_TSR_CMB4;id++) {
				HWND hCmbList = GetDlgItem(hWnd,id);
				int def = ComboBox_GetCurSel(hCmbList);
				wsprintf(szItem,"FilenameSet%d",id);
				wsprintf(szData,"%d",def);
				WritePrivateProfileString("TsRenameDlg",szItem,szData,m_szIniPath);
			}
			m_bNotFileRename = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_NOTRENAME) , BM_GETCHECK , 0 , 0));
			m_bFileDate = (BST_CHECKED == SendMessage(GetDlgItem(hWnd, IDC_TSR_FILEDATE) , BM_GETCHECK , 0 , 0));
			wsprintf(szData,"%d",m_bNotFileRename);
			WritePrivateProfileString("TsRenameDlg","NotRename",szData,m_szIniPath);
			wsprintf(szData,"%d",m_bFileDate);
			WritePrivateProfileString("TsRenameDlg","FileDate",szData,m_szIniPath);
			PostQuitMessage(0);
		}
		break;
	}
    return 0;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TSRENAME, szWindowClass, MAX_LOADSTRING);

	InitCommonControls();

	char szModulePath[256],drv[10],path[256],name[256],ext[256];
	GetModuleFileName(NULL,szModulePath,256);
	_splitpath(szModulePath,drv,path,name,ext);
	_makepath(m_szIniPath,drv,path,name,".ini");

    HWND hDlg= CreateDialog(hInstance,MAKEINTRESOURCE(IDD_TSRENAME_DLG),
        NULL,(DLGPROC)TsRenameDlgProc);
    ShowWindow(hDlg,SW_SHOW);

	MSG msg;
	HACCEL hAccel= LoadAccelerators(hInstance,MAKEINTRESOURCE(IDC_TSRENAME));
	while (GetMessage(&msg,NULL,0,0) )
	{
		if ( !TranslateAccelerator(hDlg,hAccel,&msg) && !IsDialogMessage(hDlg,&msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return 0;

	//return (int) DialogBox(hInstance,MAKEINTRESOURCE(IDD_TSRENAME_DLG),	NULL,(DLGPROC)TsRenameDlgProc);
}



//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg :
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//     Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ 
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//

// o[W{bNX̃bZ[W nhłB
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
